// PatchMaker.cpp : 응용 프로그램에 대한 클래스 동작을 정의합니다.
//

#include "stdafx.h"
#include "PatchMaker.h"
#include "PatchMakerSheet.h"

#include "AutoPatchPage.h"
#include "ManualPatchPage.h"
#include "ChecksumPage.h"
#include "SettingOptionPage.h"

#include "SettingPatchInfo.h"
#include "UtilityFunc.h"

#include "PMSettingConstant.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CPatchMakerApp

BEGIN_MESSAGE_MAP(CPatchMakerApp, CWinApp)
    ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()


// CPatchMakerApp 생성

CPatchMakerApp::CPatchMakerApp() 
: m_bAutoPatchOperate(false)
, m_bManualPatchOperate(false)
, m_lpSettingPage(NULL)
{
    // TODO: 여기에 생성 코드를 추가합니다.
    // InitInstance에 모든 중요한 초기화 작업을 배치합니다.
}


// 유일한 CPatchMakerApp 개체입니다.

CPatchMakerApp theApp;


// CPatchMakerApp 초기화

BOOL CPatchMakerApp::InitInstance()
{
    // 응용 프로그램 매니페스트가 ComCtl32.dll 버전 6 이상을 사용하여 비주얼 스타일을
    // 사용하도록 지정하는 경우, Windows XP 상에서 반드시 InitCommonControls()가 필요합니다. 
    // InitCommonControls()를 사용하지 않으면 창을 만들 수 없습니다.
    InitCommonControls();

    CWinApp::InitInstance();

    CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);

    // 표준 초기화
    // 이들 기능을 사용하지 않고 최종 실행 파일의 크기를 줄이려면
    // 아래에서 필요 없는 특정 초기화 루틴을 제거해야 합니다.
    // 해당 설정이 저장된 레지스트리 키를 변경하십시오.
    // TODO: 이 문자열을 회사 또는 조직의 이름과 같은
    // 적절한 내용으로 수정해야 합니다.
    SetRegistryKey(_T("Gamasoft PatchMaker"));

    PMConst::InitializeStrings();
    CPMSetting& pmSetting = CPMDefaultSetting::GetInstance();
    
    CString szFilePathName;
    PMUtil::GetCurrentFolderName(szFilePathName);
    szFilePathName.Append(CPMDefaultSetting::GetDefaultSettingName());

    if (!pmSetting.LoadSetting(szFilePathName))
    {
        MessageBox(NULL, _T("기본 설정 파일을 만들거나 읽어올 수 없습니다"), 
            _T("설정 파일 오류"), MB_OK | MB_ICONWARNING);
    }
    else
    {
        CSettingPatchInfo   patchInfo;
        CPMSetting          pmLocalSetting;
            
        bool bFailed = false;
        while (!bFailed)
        {
            if (IDOK == patchInfo.DoModal() && patchInfo.CheckPatchInfo())
            {
                // 설정 파일의 전체 이름 경로를 알아낸다.
                CString szSetupFileName;
                PMUtil::GetCurrentFolderName(szSetupFileName);
                szSetupFileName.Append(patchInfo.GetSetupFileName());

                if (pmLocalSetting.LoadSetting(szSetupFileName))
                {
                    CString szMinver((LPCTSTR)IDS_MIN_VER);
                    CString szMaxver((LPCTSTR)IDS_MAX_VER);

                    CString szTitle;
                    szTitle.Format("PatchMaker v%s.%s : %s : %u", szMaxver, szMinver, 
                        patchInfo.GetSetupName(), patchInfo.GetPatchVersion());

                    CPatchMakerSheet sheet(szTitle.GetString());

                    CAutoPatchPage      autoPatchPage;
                    CManualPatchPage    manualPatchPage(pmLocalSetting, patchInfo.GetPatchVersion());
                    CChecksumPage       checksumPage;
                    CSettingOptionPage  settingOptPage(pmLocalSetting, sheet);

                    sheet.AddPage(&autoPatchPage);
                    sheet.AddPage(&manualPatchPage);
                    sheet.AddPage(&checksumPage);
                    sheet.AddPage(&settingOptPage); // 이 페이지는 제일 마지막으로..

                    m_pMainWnd = &sheet;
                    m_lpSettingPage = &settingOptPage;
                    sheet.DoModal();
                }
                else
                {
                    MessageBox(NULL, _T("셋업 파일을 불러오기 위해서 여는 데 실패했습니다"), 
                        _T("파일 열기 오류"), MB_OK | MB_ICONEXCLAMATION);

                    bFailed = true;
                }
            }
            else
            {
                bFailed = true;
            }
        }
    }

    // 대화 상자가 닫혔으므로 응용 프로그램의 메시지 펌프를 시작하지 않고
    // 응용 프로그램을 끝낼 수 있도록 FALSE를 반환합니다.
    CoUninitialize();

    return FALSE;
}

void CPatchMakerApp::SetAutoPatchOperate(bool bOperate)
{
    if (0 != m_lpSettingPage && (m_bAutoPatchOperate ^ bOperate))
    {
        // 두 상태가 서로 반대 상태인 경우에만(exclusive OR) 작업을 한다.
        m_lpSettingPage->SendMessage(
            bOperate ? PMConst::AP_SETTING_DISABLE : PMConst::AP_SETTING_ENABLE, 0, 0);

        m_bAutoPatchOperate = bOperate;
    }
}

void CPatchMakerApp::SetManualPatchOperate(bool bOperate)
{
    if (0 != m_lpSettingPage && (m_bManualPatchOperate ^ bOperate))
    {
        // 두 상태가 서로 반대 상태인 경우에만(exclusive OR) 작업을 한다.
        m_lpSettingPage->SendMessage(
            bOperate ? PMConst::MP_SETTING_DISABLE : PMConst::MP_SETTING_ENABLE, 0, 0);

        m_bManualPatchOperate = bOperate;
    }
}

void CPatchMakerApp::AddTotalProgressLog(LPCTSTR szProgress)
{
    if (0 != m_pMainWnd && 0 != szProgress &&
        m_pMainWnd->IsKindOf(RUNTIME_CLASS(CPatchMakerSheet)))
    {
        CPatchMakerSheet* lpSheet = static_cast<CPatchMakerSheet*>(m_pMainWnd);
        lpSheet->GetLogEdit().AddLine(szProgress);
    }
}
